local _, addon = ...

-- functions
local ipairs = ipairs
local format = string.format
local tinsert = table.insert
-- constants
-- frames
-- libs
local LibStub = LibStub

addon.EVENT_BAG_SCAN_STARTED = "BAG_SCAN_STARTED"
addon.EVENT_BAG_SCAN_FINISHED = "BAG_SCAN_FINISHED"
addon.EVENT_CHARACTER_ADDED = "CHARACTER_ADDED"
addon.EVENT_CHARACTER_CHANGED = "CHARACTER_CHANGED"
addon.EVENT_CHARACTER_REMOVED = "CHARACTER_REMOVED"
addon.EVENT_KEYSTONE = "KEYSTONE"
addon.EVENT_GUILD_INFO_CHANGED = "GUILD_INFO_CHANGED"
addon.EVENT_PLAYER_INFO_CHANGED = "PLAYER_INFO_CHANGED"

addon.EVENT_INITIALISED = "INITIALISED"

-- messy stub of CallbackHandler that doesn't overwrite existing handlers when registering new ones
addon.callbacks = {}
function addon:Fire(event, ...)
    self:Print(format("Fired: `%s` (%d listeners)", event, (self.callbacks[event] and #self.callbacks[event] or 0)))

    if not self.callbacks[event] then return end

    for _, f in ipairs(self.callbacks[event]) do
        f(event, ...)
    end
end

function addon:RegisterCallback(event, f)
    if not self.callbacks[event] then self.callbacks[event] = {} end

    self:Print(format("Register: `%s`", event))

    tinsert(self.callbacks[event], f)
end
